let
  pkgs = import ./nix/pkgs.nix {};
  settings = import ./nix/settings.nix;
  haskellDeps = import ./nix/haskell-deps.nix;

  haskellPackages = pkgs.haskell.packages."${settings.ghc}";

  utoy =
    { mkDerivation }:
    mkDerivation {
      version = "0.3";
      pname = "utoy";
      license = pkgs.lib.licenses.mit;
      src =
        let
          buildFiles = [
            ./LICENSE
            ./utoy.cabal
            ./Setup.hs
            ./app
            ./src
            ./static
            ./test
          ];
        in
          pkgs.lib.sources.cleanSourceWith {
            src = ./.;
            filter = path: _type: pkgs.lib.any (prefix: pkgs.lib.hasPrefix (toString prefix) path) buildFiles;
          };

      libraryHaskellDepends = haskellDeps haskellPackages;
    };
in
  pkgs.haskell.lib.justStaticExecutables
    (haskellPackages.callPackage utoy {})
